from typing import Any as _py_Any
from typing import overload
import cern.japc.value
import java.io


class TypedObject(java.io.Serializable):
    def getType(self) -> cern.japc.value.Type: ...

class AbstractValueDescriptor(TypedObject, cern.japc.value.ValueDescriptor, java.io.Serializable):
    def getName(self) -> str: ...
    def isConstant(self) -> bool: ...
    def setConstant(self, boolean: bool) -> None: ...
    def setName(self, string: str) -> None: ...

class ParameterValueImpl(TypedObject, cern.japc.value.ParameterValue, java.io.Serializable):
    @overload
    def __init__(self, type: cern.japc.value.Type): ...
    @overload
    def __init__(self, type: cern.japc.value.Type, valueDescriptor: cern.japc.value.ValueDescriptor): ...
    def clone(self) -> _py_Any: ...
    def getDescriptor(self) -> cern.japc.value.ValueDescriptor: ...
    def isMutable(self) -> bool: ...
    def makeImmutable(self) -> None: ...
    def makeMutable(self) -> cern.japc.value.ParameterValue: ...
    def setDescriptor(self, valueDescriptor: cern.japc.value.ValueDescriptor) -> None: ...
    def setMutable(self, boolean: bool) -> None: ...
