from typing import overload
import cern.accsoft.commons.util
import cern.accsoft.commons.value
import cern.lsa.domain.cern.optics
import cern.lsa.domain.commons.spi
import java.io
import java.lang
import java.util


class FidelModelImpl(cern.lsa.domain.commons.spi.AbstractIdentifiedNamedEntity[cern.lsa.domain.cern.optics.FidelModel], cern.lsa.domain.cern.optics.FidelModel, java.io.Serializable):
    def __init__(self, long: int, string: str, string2: str): ...
    def addComponent(self, string: str) -> None: ...
    def findModelCoefficients(self, string: str) -> java.util.Map[str, float]: ...
    def getCoeffMap(self) -> java.util.Map[str, java.util.Map[str, float]]: ...
    def getComponentsNames(self) -> java.util.Set[str]: ...
    def getModelId(self) -> int: ...
    def getModelName(self) -> str: ...
    def setCoeffMap(self, map: java.util.Map[str, java.util.Map[str, float]]) -> None: ...

class FidelTaskResultImpl(cern.lsa.domain.cern.optics.FidelTaskResult, java.io.Serializable):
    @overload
    def __init__(self, fidelTaskResultEnum: cern.lsa.domain.cern.optics.FidelTaskResult.FidelTaskResultEnum): ...
    @overload
    def __init__(self, fidelTaskResultEnum: cern.lsa.domain.cern.optics.FidelTaskResult.FidelTaskResultEnum, exception: java.lang.Exception): ...
    @overload
    def __init__(self, fidelTaskResultEnum: cern.lsa.domain.cern.optics.FidelTaskResult.FidelTaskResultEnum, string: str): ...
    def addException(self, exception: java.lang.Exception) -> None: ...
    def addMessage(self, string: str) -> None: ...
    def getAllMessages(self) -> str: ...
    def getExceptions(self) -> java.util.List[java.lang.Exception]: ...
    def getLastException(self) -> java.lang.Exception: ...
    def getMessages(self) -> java.util.List[str]: ...
    def getResult(self) -> cern.lsa.domain.cern.optics.FidelTaskResult.FidelTaskResultEnum: ...
    def merge(self, fidelTaskResult: cern.lsa.domain.cern.optics.FidelTaskResult) -> cern.lsa.domain.cern.optics.FidelTaskResult: ...
    def mergeResult(self, fidelTaskResultEnum: cern.lsa.domain.cern.optics.FidelTaskResult.FidelTaskResultEnum) -> None: ...
    def setResult(self, fidelTaskResultEnum: cern.lsa.domain.cern.optics.FidelTaskResult.FidelTaskResultEnum) -> None: ...

class FieldHarmonicImpl(cern.accsoft.commons.util.AbstractNamedSerializable, cern.lsa.domain.cern.optics.FieldHarmonic):
    def __init__(self, string: str, date: java.util.Date, immutableDiscreteFunction: cern.accsoft.commons.value.ImmutableDiscreteFunction): ...
    def getComponentName(self) -> str: ...
    def getCreationDate(self) -> java.util.Date: ...
    def getCurrent2CnFunction(self) -> cern.accsoft.commons.value.ImmutableDiscreteFunction: ...
    def getModelName(self) -> str: ...
    def setComponentName(self, string: str) -> None: ...
    def setModelName(self, string: str) -> None: ...
