from typing import Any as _py_Any
from typing import List as _py_List
from typing import TypeVar as _py_TypeVar
from typing import Type as _py_Type
from typing import ClassVar as _py_ClassVar
from typing import overload
import cern.lsa.domain.devices.type
import com.google.common.collect
import java.io
import java.lang
import java.util


class IncaPropertyFieldInfo:
    @classmethod
    def builder(cls) -> 'DefaultIncaPropertyFieldInfo.Builder': ...
    def getAssociatedPropertyField(self) -> cern.lsa.domain.devices.type.PropertyField: ...
    def getControlWarningMessage(self) -> str: ...
    def getDisplayFormat(self) -> str: ...
    def getDisplayName(self) -> str: ...
    def getParameterValueCompareType(self) -> 'IncaPropertyFieldInfo.ValueCompareType': ...
    def getPropertyField(self) -> cern.lsa.domain.devices.type.PropertyField: ...
    def isMainStatus(self) -> bool: ...
    class ValueCompareType(java.lang.Enum['IncaPropertyFieldInfo.ValueCompareType']):
        EXACT_MEANING: _py_ClassVar['IncaPropertyFieldInfo.ValueCompareType'] = ...
        TOL_REL: _py_ClassVar['IncaPropertyFieldInfo.ValueCompareType'] = ...
        TOL_ABS: _py_ClassVar['IncaPropertyFieldInfo.ValueCompareType'] = ...
        EXACT: _py_ClassVar['IncaPropertyFieldInfo.ValueCompareType'] = ...
        TOL_ABS_REL: _py_ClassVar['IncaPropertyFieldInfo.ValueCompareType'] = ...
        TOL_ABS_MOD360: _py_ClassVar['IncaPropertyFieldInfo.ValueCompareType'] = ...
        NONE: _py_ClassVar['IncaPropertyFieldInfo.ValueCompareType'] = ...
        @classmethod
        @overload
        def valueOf(cls, string: str) -> 'IncaPropertyFieldInfo.ValueCompareType': ...
        _valueOf_1__T = _py_TypeVar('_valueOf_1__T', bound=java.lang.Enum)  # <T>
        @classmethod
        @overload
        def valueOf(cls, class_: _py_Type[_valueOf_1__T], string: str) -> _valueOf_1__T: ...
        @classmethod
        def values(cls) -> _py_List['IncaPropertyFieldInfo.ValueCompareType']: ...

class IncaPropertyFieldInfosRequest:
    @classmethod
    def builder(cls) -> 'DefaultIncaPropertyFieldInfosRequest.Builder': ...
    @classmethod
    def byPropertyField(cls, propertyField: cern.lsa.domain.devices.type.PropertyField) -> 'IncaPropertyFieldInfosRequest': ...
    @classmethod
    def byPropertyFields(cls, set: java.util.Set[cern.lsa.domain.devices.type.PropertyField]) -> 'IncaPropertyFieldInfosRequest': ...
    def getPropertyFields(self) -> java.util.Set[cern.lsa.domain.devices.type.PropertyField]: ...

class DefaultIncaPropertyFieldInfo(IncaPropertyFieldInfo, java.io.Serializable):
    @classmethod
    def builder(cls) -> 'DefaultIncaPropertyFieldInfo.Builder': ...
    @classmethod
    def copyOf(cls, incaPropertyFieldInfo: IncaPropertyFieldInfo) -> 'DefaultIncaPropertyFieldInfo': ...
    def equals(self, object: _py_Any) -> bool: ...
    def getAssociatedPropertyField(self) -> cern.lsa.domain.devices.type.PropertyField: ...
    def getControlWarningMessage(self) -> str: ...
    def getDisplayFormat(self) -> str: ...
    def getDisplayName(self) -> str: ...
    def getParameterValueCompareType(self) -> IncaPropertyFieldInfo.ValueCompareType: ...
    def getPropertyField(self) -> cern.lsa.domain.devices.type.PropertyField: ...
    def hashCode(self) -> int: ...
    def isMainStatus(self) -> bool: ...
    def toString(self) -> str: ...
    def withAssociatedPropertyField(self, propertyField: cern.lsa.domain.devices.type.PropertyField) -> 'DefaultIncaPropertyFieldInfo': ...
    def withControlWarningMessage(self, string: str) -> 'DefaultIncaPropertyFieldInfo': ...
    def withDisplayFormat(self, string: str) -> 'DefaultIncaPropertyFieldInfo': ...
    def withDisplayName(self, string: str) -> 'DefaultIncaPropertyFieldInfo': ...
    def withMainStatus(self, boolean: bool) -> 'DefaultIncaPropertyFieldInfo': ...
    def withParameterValueCompareType(self, valueCompareType: IncaPropertyFieldInfo.ValueCompareType) -> 'DefaultIncaPropertyFieldInfo': ...
    def withPropertyField(self, propertyField: cern.lsa.domain.devices.type.PropertyField) -> 'DefaultIncaPropertyFieldInfo': ...
    class Builder:
        def associatedPropertyField(self, propertyField: cern.lsa.domain.devices.type.PropertyField) -> 'DefaultIncaPropertyFieldInfo.Builder': ...
        def build(self) -> 'DefaultIncaPropertyFieldInfo': ...
        def controlWarningMessage(self, string: str) -> 'DefaultIncaPropertyFieldInfo.Builder': ...
        def displayFormat(self, string: str) -> 'DefaultIncaPropertyFieldInfo.Builder': ...
        def displayName(self, string: str) -> 'DefaultIncaPropertyFieldInfo.Builder': ...
        def mainStatus(self, boolean: bool) -> 'DefaultIncaPropertyFieldInfo.Builder': ...
        def parameterValueCompareType(self, valueCompareType: IncaPropertyFieldInfo.ValueCompareType) -> 'DefaultIncaPropertyFieldInfo.Builder': ...
        def propertyField(self, propertyField: cern.lsa.domain.devices.type.PropertyField) -> 'DefaultIncaPropertyFieldInfo.Builder': ...

class DefaultIncaPropertyFieldInfosRequest(IncaPropertyFieldInfosRequest, java.io.Serializable):
    @classmethod
    def builder(cls) -> 'DefaultIncaPropertyFieldInfosRequest.Builder': ...
    @classmethod
    def copyOf(cls, incaPropertyFieldInfosRequest: IncaPropertyFieldInfosRequest) -> 'DefaultIncaPropertyFieldInfosRequest': ...
    def equals(self, object: _py_Any) -> bool: ...
    @overload
    def getPropertyFields(self) -> com.google.common.collect.ImmutableSet[cern.lsa.domain.devices.type.PropertyField]: ...
    @overload
    def getPropertyFields(self) -> java.util.Set: ...
    def hashCode(self) -> int: ...
    def toString(self) -> str: ...
    @overload
    def withPropertyFields(self, propertyFieldArray: _py_List[cern.lsa.domain.devices.type.PropertyField]) -> 'DefaultIncaPropertyFieldInfosRequest': ...
    @overload
    def withPropertyFields(self, iterable: java.lang.Iterable[cern.lsa.domain.devices.type.PropertyField]) -> 'DefaultIncaPropertyFieldInfosRequest': ...
    class Builder:
        def addAllPropertyFields(self, iterable: java.lang.Iterable[cern.lsa.domain.devices.type.PropertyField]) -> 'DefaultIncaPropertyFieldInfosRequest.Builder': ...
        def addPropertyField(self, propertyField: cern.lsa.domain.devices.type.PropertyField) -> 'DefaultIncaPropertyFieldInfosRequest.Builder': ...
        def addPropertyFields(self, propertyFieldArray: _py_List[cern.lsa.domain.devices.type.PropertyField]) -> 'DefaultIncaPropertyFieldInfosRequest.Builder': ...
        def build(self) -> 'DefaultIncaPropertyFieldInfosRequest': ...
        def propertyFields(self, iterable: java.lang.Iterable[cern.lsa.domain.devices.type.PropertyField]) -> 'DefaultIncaPropertyFieldInfosRequest.Builder': ...
