from typing import Any as _py_Any
from typing import List as _py_List
from typing import Type as _py_Type
from typing import ClassVar as _py_ClassVar
from typing import overload
import java.awt
import java.awt.geom
import java.awt.image
import java.io
import java.lang
import java.util


class ParameterBlock(java.lang.Cloneable, java.io.Serializable):
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, vector: java.util.Vector[_py_Any]): ...
    @overload
    def __init__(self, vector: java.util.Vector[_py_Any], vector2: java.util.Vector[_py_Any]): ...
    @overload
    def add(self, byte: int) -> 'ParameterBlock': ...
    @overload
    def add(self, char: str) -> 'ParameterBlock': ...
    @overload
    def add(self, double: float) -> 'ParameterBlock': ...
    @overload
    def add(self, float: float) -> 'ParameterBlock': ...
    @overload
    def add(self, int: int) -> 'ParameterBlock': ...
    @overload
    def add(self, object: _py_Any) -> 'ParameterBlock': ...
    @overload
    def add(self, long: int) -> 'ParameterBlock': ...
    @overload
    def add(self, short: int) -> 'ParameterBlock': ...
    def addSource(self, object: _py_Any) -> 'ParameterBlock': ...
    def clone(self) -> _py_Any: ...
    def getByteParameter(self, int: int) -> int: ...
    def getCharParameter(self, int: int) -> str: ...
    def getDoubleParameter(self, int: int) -> float: ...
    def getFloatParameter(self, int: int) -> float: ...
    def getIntParameter(self, int: int) -> int: ...
    def getLongParameter(self, int: int) -> int: ...
    def getNumParameters(self) -> int: ...
    def getNumSources(self) -> int: ...
    def getObjectParameter(self, int: int) -> _py_Any: ...
    def getParamClasses(self) -> _py_List[_py_Type]: ...
    def getParameters(self) -> java.util.Vector[_py_Any]: ...
    def getRenderableSource(self, int: int) -> 'RenderableImage': ...
    def getRenderedSource(self, int: int) -> java.awt.image.RenderedImage: ...
    def getShortParameter(self, int: int) -> int: ...
    def getSource(self, int: int) -> _py_Any: ...
    def getSources(self) -> java.util.Vector[_py_Any]: ...
    def removeParameters(self) -> None: ...
    def removeSources(self) -> None: ...
    @overload
    def set(self, byte: int, int: int) -> 'ParameterBlock': ...
    @overload
    def set(self, char: str, int: int) -> 'ParameterBlock': ...
    @overload
    def set(self, double: float, int: int) -> 'ParameterBlock': ...
    @overload
    def set(self, float: float, int: int) -> 'ParameterBlock': ...
    @overload
    def set(self, int: int, int2: int) -> 'ParameterBlock': ...
    @overload
    def set(self, object: _py_Any, int: int) -> 'ParameterBlock': ...
    @overload
    def set(self, long: int, int: int) -> 'ParameterBlock': ...
    @overload
    def set(self, short: int, int: int) -> 'ParameterBlock': ...
    def setParameters(self, vector: java.util.Vector[_py_Any]) -> None: ...
    def setSource(self, object: _py_Any, int: int) -> 'ParameterBlock': ...
    def setSources(self, vector: java.util.Vector[_py_Any]) -> None: ...
    def shallowClone(self) -> _py_Any: ...

class RenderContext(java.lang.Cloneable):
    @overload
    def __init__(self, affineTransform: java.awt.geom.AffineTransform): ...
    @overload
    def __init__(self, affineTransform: java.awt.geom.AffineTransform, renderingHints: java.awt.RenderingHints): ...
    @overload
    def __init__(self, affineTransform: java.awt.geom.AffineTransform, shape: java.awt.Shape): ...
    @overload
    def __init__(self, affineTransform: java.awt.geom.AffineTransform, shape: java.awt.Shape, renderingHints: java.awt.RenderingHints): ...
    def clone(self) -> _py_Any: ...
    def concatenateTransform(self, affineTransform: java.awt.geom.AffineTransform) -> None: ...
    def concetenateTransform(self, affineTransform: java.awt.geom.AffineTransform) -> None: ...
    def getAreaOfInterest(self) -> java.awt.Shape: ...
    def getRenderingHints(self) -> java.awt.RenderingHints: ...
    def getTransform(self) -> java.awt.geom.AffineTransform: ...
    def preConcatenateTransform(self, affineTransform: java.awt.geom.AffineTransform) -> None: ...
    def preConcetenateTransform(self, affineTransform: java.awt.geom.AffineTransform) -> None: ...
    def setAreaOfInterest(self, shape: java.awt.Shape) -> None: ...
    def setRenderingHints(self, renderingHints: java.awt.RenderingHints) -> None: ...
    def setTransform(self, affineTransform: java.awt.geom.AffineTransform) -> None: ...

class RenderableImage:
    HINTS_OBSERVED: _py_ClassVar[str] = ...
    def createDefaultRendering(self) -> java.awt.image.RenderedImage: ...
    def createRendering(self, renderContext: RenderContext) -> java.awt.image.RenderedImage: ...
    def createScaledRendering(self, int: int, int2: int, renderingHints: java.awt.RenderingHints) -> java.awt.image.RenderedImage: ...
    def getHeight(self) -> float: ...
    def getMinX(self) -> float: ...
    def getMinY(self) -> float: ...
    def getProperty(self, string: str) -> _py_Any: ...
    def getPropertyNames(self) -> _py_List[str]: ...
    def getSources(self) -> java.util.Vector['RenderableImage']: ...
    def getWidth(self) -> float: ...
    def isDynamic(self) -> bool: ...

class RenderableImageProducer(java.awt.image.ImageProducer, java.lang.Runnable):
    def __init__(self, renderableImage: RenderableImage, renderContext: RenderContext): ...
    def addConsumer(self, imageConsumer: java.awt.image.ImageConsumer) -> None: ...
    def isConsumer(self, imageConsumer: java.awt.image.ImageConsumer) -> bool: ...
    def removeConsumer(self, imageConsumer: java.awt.image.ImageConsumer) -> None: ...
    def requestTopDownLeftRightResend(self, imageConsumer: java.awt.image.ImageConsumer) -> None: ...
    def run(self) -> None: ...
    def setRenderContext(self, renderContext: RenderContext) -> None: ...
    def startProduction(self, imageConsumer: java.awt.image.ImageConsumer) -> None: ...

class RenderedImageFactory:
    def create(self, parameterBlock: ParameterBlock, renderingHints: java.awt.RenderingHints) -> java.awt.image.RenderedImage: ...

class ContextualRenderedImageFactory(RenderedImageFactory):
    @overload
    def create(self, renderContext: RenderContext, parameterBlock: ParameterBlock) -> java.awt.image.RenderedImage: ...
    @overload
    def create(self, parameterBlock: ParameterBlock, renderingHints: java.awt.RenderingHints) -> java.awt.image.RenderedImage: ...
    def getBounds2D(self, parameterBlock: ParameterBlock) -> java.awt.geom.Rectangle2D: ...
    def getProperty(self, parameterBlock: ParameterBlock, string: str) -> _py_Any: ...
    def getPropertyNames(self) -> _py_List[str]: ...
    def isDynamic(self) -> bool: ...
    def mapRenderContext(self, int: int, renderContext: RenderContext, parameterBlock: ParameterBlock, renderableImage: RenderableImage) -> RenderContext: ...

class RenderableImageOp(RenderableImage):
    def __init__(self, contextualRenderedImageFactory: ContextualRenderedImageFactory, parameterBlock: ParameterBlock): ...
    def createDefaultRendering(self) -> java.awt.image.RenderedImage: ...
    def createRendering(self, renderContext: RenderContext) -> java.awt.image.RenderedImage: ...
    def createScaledRendering(self, int: int, int2: int, renderingHints: java.awt.RenderingHints) -> java.awt.image.RenderedImage: ...
    def getHeight(self) -> float: ...
    def getMinX(self) -> float: ...
    def getMinY(self) -> float: ...
    def getParameterBlock(self) -> ParameterBlock: ...
    def getProperty(self, string: str) -> _py_Any: ...
    def getPropertyNames(self) -> _py_List[str]: ...
    def getSources(self) -> java.util.Vector[RenderableImage]: ...
    def getWidth(self) -> float: ...
    def isDynamic(self) -> bool: ...
    def setParameterBlock(self, parameterBlock: ParameterBlock) -> ParameterBlock: ...
